"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var jsondebugoutput_module_scss_1 = __importDefault(require("./jsondebugoutput.module.scss"));
function syntaxHighlight(json) {
    if (!json)
        return ''; // no JSON from response
    json = json
        .replace(/&/g, '&amp;')
        .replace(/</g, '&lt;')
        .replace(/>/g, '&gt;');
    return json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
        var cls = jsondebugoutput_module_scss_1.default.number;
        if (/^"/.test(match)) {
            if (/:$/.test(match)) {
                cls = jsondebugoutput_module_scss_1.default.key;
            }
            else {
                cls = jsondebugoutput_module_scss_1.default.string;
            }
        }
        else if (/true|false/.test(match)) {
            cls = jsondebugoutput_module_scss_1.default.boolean;
        }
        else if (/null/.test(match)) {
            cls = jsondebugoutput_module_scss_1.default.null;
        }
        return "<span class=\"".concat(cls, "\">").concat(match, "</span>");
    });
}
function JsonDebugOutput(_a) {
    var json = _a.json, _b = _a.title, title = _b === void 0 ? 'debug' : _b;
    return (react_1.default.createElement("div", { className: jsondebugoutput_module_scss_1.default.container },
        react_1.default.createElement("h2", { className: jsondebugoutput_module_scss_1.default.title }, title),
        react_1.default.createElement("pre", { className: jsondebugoutput_module_scss_1.default.pre, dangerouslySetInnerHTML: {
                __html: syntaxHighlight(JSON.stringify(json, undefined, 4)),
            } })));
}
exports.default = JsonDebugOutput;
